"""
POWER BUSINESS SYSTEMS
Copyright 2010 Power Business Systems <jasper@powerbs.co.za>
All Rights Reserved.

Licensed under The Artistic License 2.0
See LICENSE for details or
http://www.perlfoundation.org/artistic_license_2_0
"""
import socket
import time
from log import log 
from clan_lib import clan_lib
from clan_lib import bridge_result                                                                                                                                                    

__version__ = "1.01"

class clan_client(clan_lib, bridge_result) :
    sock = False
    connected = False
    req_str = ""
    host = ""
    port = ""
    def __init__(self, host, port) :
        
        if host != "" and port != "" :
            self.host = host
            self.port = port
            self.connect(host, port)

    def connect(self, host, port) :
        self.sock = socket.socket(socket.AF_INET, socket.SOCK_STREAM)
        self.sock.settimeout(30)
        try :
            self.sock.connect( (host, port) )
        except :
            self.connected = False
            return
        self.connected = True 
        #self.sock.settimeout(None)

    def is_connected (self) :
        return self.connected

    def close(self) :
        self.sock.close()

    def rpc(self, method, args) :
        if not self.connected:
            self.connect(self.host, self.port)
        if not self.connected:
            return bridge_result(self.create_rpc_connerr("Could not connect to local clan", "0")) 
        try:
            self.req_str = self.create_rpc_str ("rpc", method, args)
            self.req_str = str(len(self.req_str)) + "*" + self.req_str
            self.sock.send(self.req_str)
            max_head = 15
            head = ""
            body_len = long(0)
            buff = ""

            while 1:
                if body_len == 0 :
                    
                    buff = self.sock.recv(1)
                    if buff == "*" :
                        body_len = long(head)
                        break
                    if buff == "" :
                        break
                    head = head + buff
                    if len(head) > max_head :
                        break
                    continue
            buff = ""
            while len(buff) < body_len :
                buff+= self.sock.recv(body_len - len(buff))
            return bridge_result(buff)
        except:
            return bridge_result(self.create_rpc_connerr("Error fetching results, connection could be down.", "0")) 


