"""
POWER BUSINESS SYSTEMS
Copyright 2010 Power Business Systems <jasper@powerbs.co.za>
All Rights Reserved.

Licensed under The Artistic License 2.0
See LICENSE for details or
http://www.perlfoundation.org/artistic_license_2_0
"""

from threading import Thread
from log import log

class daemon(Thread) :
    dbconn = None
    alive = True
    name = ""
    parent = None
    def __init__(self, name, parent) :
        self.name = name
        self.parent = parent
        self.events = []
        self._init_listener()
        Thread.__init__(self)
        #self._set_started()
        
    def _init_listener(self) :
        if not self.parent :
            log("clan_daemon: No parent to fetch events from")
            return
        self.parent.event_listeners.append(self.events)
    def _rm_listener(self) : 
        if not self.parent :
            log("clan_daemon: No parent to fetch events from")
            return
        i = 0
        for l in self.parent.event_listeners :
            if l == self.events :
                self.parent.event_listeners.pop(i)
            i+= 1
    def get_event(self) :
        if len(self.events) > 0 :
            return self.events.pop(0)
        return None
    def has_events(self) :
        if len(self.events) > 0 :
            return True
        return False
    def stop(self):
        self._set_stopped()
        self.alive = False
    def _set_stopped(self):
        self._set_state(0) 
    def _set_started(self):
        self._set_state(1) 
    def _set_state(self, int_state):
        d = self.parent.daemons
        try:
            d[self.name].running = int_state
        except:
            log("[%s] Could not set daemon state to %s" % (self.name, int_state))


