import SimpleHTTPServer
import Cookie
import BaseHTTPServer
import httplib
import CGIHTTPServer
import string
import mimetypes
import cgi
import os
import base64 
import sys
import re
import thread
import SocketServer
import select
import time

from clan_daemon import daemon
from clan_client import clan_client
from log import log

def getfqdn(name=''): 
    return name       
import socket         
socket.getfqdn=getfqdn
                        
                        
            

__version__ = "0.11"
__lock_version__ = False 


"""
Changelog:

2008-05-20
Added Cookie support, 
cookie object gets passed to included cgi scripts
cgi scripts can write http headers

TODO:

Possibly cut out direct rpc requests, esp with an open webserver. 
Or have some sort of authentication which wont be a nightmare to maintain.

"""

class XMLHttpRequestHandler (CGIHTTPServer.CGIHTTPRequestHandler):
    """http request handler with QUIT stopping the server"""
    #auth_basic = ""
    out_cookies = []
    in_cookies = "" 
    def do_QUIT (self):
        """send 200 OK response, and set server.stop to True"""
        self.send_response(200)
        self.end_headers()
        self.server.stop = True
    def do_GET (self):
        self.parseRequestLine()
        log("Got: " + self.path + " in GET")
        self.do_request()

    def do_POST (self):
        self.parseRequestLine()
        log("Got: " + self.path + " in POST")
        self.do_request()

    def do_request(self):
        self.cgi_directories = ['']        
        if self.is_cgi() :
            self.run_py()
        else :
            self.path = self.path.split("?")[0]
            if os.path.isfile ( ("http/"+self.path) ) :
                f = open( ("http/"+self.path), "rb")
                content = f.read()
                self.send_response(200)
                mimetypes.init()
                if self.ext == "" :
                    ext = "html"
                else :
                    ext = self.ext
                if mimetypes.types_map.has_key(ext.lower()):    
                    type = mimetypes.types_map[ext.lower()]
                    self.send_header('Content-Type', type)        
                self.end_headers()
                self.wfile.write (content)                
            else :
                self.send_error (401, "Not found")


    def is_cgi (self) :
        # add more checks here. should also use the cgi_dir's
        
        if self.ext == ".py" :
            return True
        if os.path.isfile( (self.script_rel_path + ".py" ) ) :
            return True
        
        return False    

    def gen401 (self) :
        msg = """
            <html>
              <head><title>401</title></head>
              <body><b>You need to be logged in</b></body>
            </html>\0""";
        self.send_response(401)
        self.send_header('WWW-Authenticate', 'Basic realm="Login required"')
        self.end_headers()
        self.wfile.write (msg)            


    def run_py (self):
        if self.command == 'POST':
            cntlen = int (self.headers.getheader('content-length'))
            form = ""
            if cntlen > 0:
                form = self.rfile.read(cntlen)
            #    #tot_read = 0
            #    #while (tot_read < (cntlen -1)) :
            #    #    form = form + self.rfile.readline() 
            #    #    tot_read = len(form)
            else:
                form = string.strip (self.rfile.readline())                
            # throw away additional data [see bug #427345]  <- from CGIHTTPServer.py
            while select.select([self.rfile._sock], [], [], 0)[0]:
                buff = self.rfile._sock.recv(128)
                if not buff:
                    break
                form+= buff

            if self.query:
                form = form + "&" + string.strip(self.query)
        else:
            
            form = string.strip (self.query)
        req = cgi.parse_qs (form, 1)
        imp_script = re.sub('.py$', '', self.script)
        html = ""
        out_headers = {}
        out_headers["Content-Type"] = "text/html"

        if os.path.exists(self.script_rel_path) or os.path.exists(self.script_rel_path + ".py") : 
            try:
                sys.path.insert(0, os.path.dirname(self.script_abs_path))
                try:
                    del(sys.modules[imp_script])
                except:
                    pass
                imp = __import__(imp_script)
                imp._form = form
                #imp._cookie = Cookie.SimpleCookie(self.headers.getheader("cookie"))
                self.in_cookies = Cookie.SimpleCookie(self.headers.getheader("cookie"))
                imp._http = self
                imp._out_headers = out_headers
                for a in req:
                    if a[:2] == "__":
                        continue 
                    try:
                        exec("imp.%s = req.get(a)[0]" % a)
                    except:
                        log(sys.exc_value)
                        pass                        
                imp._working_dir = os.path.dirname(self.script_abs_path)
                # below line is for backward compatibility, remove eventually 
                imp.working_dir = os.path.dirname(self.script_abs_path)
                html = imp.run(req)
                del imp
            except:
                log("LWebserv: Could not import web script")
                log(sys.exc_value)
                html = "<b>Script error: %s</b>" % sys.exc_value
        if html == "_gen401" :
            return self.gen401()	    
        self.send_response(200)
        if not html:
            html = ""
            cntlen = 0
        else:
            cntlen = len(html)       
        for head in out_headers: 
            self.send_header(head, out_headers[head])       
        for row in self.out_cookies:
            for key in row:
                self.send_header('Set-Cookie', '%s=%s' % (key, row[key]))
        self.send_header('Content-Length', cntlen)
        #self.send_header('Set-Cookie', 'testvar=hellooo')
        self.end_headers()
        self.wfile.write (html)  

    def setCookie(self, name, value, expires=0, path="", domain="", http_only=False):
        if expires:
            try:
                # not sure if i should be using gmtime here or localtime
                format_exp = time.strftime("%a, %d-%b-%Y %H-%M-%S GMT", time.gmtime(float(expires)))
                value+= "; expires=%s" % format_exp
            except:
                pass
        if path:
            value+= "; path=%s" % path
        if domain:
            value+= "; domain=%s" % domain
        if http_only:
            value+= "; HttpOnly"
        self.out_cookies.append({name:value})

    def getCookie(self, name):
        if self.in_cookies.has_key(name):
            return self.in_cookies.get(name).value
        return False 

    def hasCookie(self, name):
        if self.in_cookies.has_key(name):
            return True 
        return False 
          
    def parseRequestLine (self):
        path = self.path
        if re.match(r'.*\?.*', path) :
            path, self.query = re.split(r'\?', path)
        else :
            self.query = ""
        self.script_rel_path = "http/" + path
        self.script_abs_path = self.translate_path(self.script_rel_path)
        parts = re.split(r'/', self.script_rel_path)
        self.script = parts[-1:][0]
        self.set_ext(self.script)
    def set_ext (self, fname) :
        fname = fname.split("?")[0]
        m = re.match(r'.*(\.[a-zA-Z0-9]*$)', fname)
        self.ext = ""
        if m :
            self.ext = m.groups(1)[0]        
    def set_root (self, path):
        # make the request document root directory the current directory
        os.chdir(path)

class XMLHTTPServer(SocketServer.ThreadingTCPServer):
    allow_reuse_address = 1    # Seems to make sense in testing environment
    def server_bind(self):
        #Override server_bind to store the server name.
        SocketServer.TCPServer.server_bind(self)
        host, port = self.socket.getsockname()[:2]
        self.server_name = socket.getfqdn(host)
        self.server_port = port

class webserv(daemon):
    alive = True
    httpd = None    
    def __init__(self,name,parent):
        daemon.__init__(self,name,parent)
        self.httpd = None			
    def stop(self):
        self.httpd.stop = True
        self._set_stopped()
        self.alive = False
	    

    def run(self):
        sys.path.append("http")       
        cfg = __import__("clanrc")
        try:
            port = cfg.local_webserv_port
        except:
            port = 40000 
        address = ("", port)
 
        self.httpd = XMLHTTPServer(address, XMLHttpRequestHandler)
        self.httpd.clan = self.parent
        log("waiting for connections...")
        while self.alive:
            #httpd.serve_forever()
            try:
                self.httpd.handle_request()
            except:
                log("LWebserv: Could not handle request")


if __name__ == "__main__" :
   
    sys.path.append("modules")
    sys.path.append("http/orders")        
    sys.path.append("http")        
    address = ("", 40000)

    httpd = XMLHTTPServer(address, XMLHttpRequestHandler)
    log("waiting for connections...")
    httpd.serve_forever()
