"""
POWER BUSINESS SYSTEMS
Copyright 2010 Power Business Systems <jasper@powerbs.co.za>
All Rights Reserved.

Licensed under The Artistic License 2.0
See LICENSE for details or
http://www.perlfoundation.org/artistic_license_2_0
"""


import sys
import os
import thread
import time
import gtk
import subprocess
from signal import SIGTERM
sys.path.append(os.path.abspath('.'))
sys.path.append("lib")
sys.path.append("gui")
sys.path.append("daemons")
sys.path.append("modules")
sys.path.append("http")       
from log import log
from clan_client import clan_client
from clan_host import clan_host


ch = None

def run_clan_host():
    global ch
    cfg = __import__("clanrc")
    ch = clan_host(cfg.hostname, "",  cfg.read_port)
    ch.connect_clans() 
    try :
        ch.run()
    except :
        log(sys.exc_value)

def close_clan_host(widget=None):
    global ch
    ch.running = False
    time.sleep(2)

def close_all(widget=None):
    close_clan_host()
    os.popen("killall chrome").close()
    gtk.main_quit()
    time.sleep(1)
    os.kill(os.getpid(), SIGTERM)

def showmenu(widget=None):
    #    "google-chrome",
    time.sleep(3) 
    subprocess.Popen([
        "gui/google/chrome/chrome", 
        "--disable-popup-blocking",
        "--app=http://localhost:50002/index"
    ])
    #subprocess.Popen(["xulrunner", "gui/main/application.ini"])
    #os.spawnv(os.P_NOWAIT, cmd, (cmd,) + args)

def show_icon():
    cfg = __import__("clanrc")

    statusIcon=gtk.status_icon_new_from_file(cfg.taskbar_icon)
    statusIcon.set_tooltip(cfg.taskbar_title)

    menu = gtk.Menu()

    menuItem = gtk.ImageMenuItem("Quit", "")
    menuItem.connect('activate', close_all)
    menu.append(menuItem)


    menuItem = gtk.ImageMenuItem("Open application", "")
    menuItem.connect('activate', showmenu)
    menu.append(menuItem)

    statusIcon.connect('activate', activate_icon_cb)
    statusIcon.connect('popup-menu', popup_menu_cb, menu)     

def popup_menu_cb(widget, button, time, data = None):
    if button == 3:
        if data:
            data.show_all()
            data.popup(None, None, None, 3, time)


def activate_icon_cb(widget, data = None):
    log("actived icon..")    


def init():
    cfg = __import__("clanrc")
    cc = clan_client("localhost", cfg.read_port)
    if cc.is_connected():
        showmenu()
        return 
    gtk.gdk.threads_init()
    thread.start_new_thread(run_clan_host,())
    thread.start_new_thread(showmenu,())
    show_icon()
    gtk.main()


if __name__ == "__main__":
    init()
