"""
POWER BUSINESS SYSTEMS
Copyright 2010 Power Business Systems <jasper@powerbs.co.za>
All Rights Reserved.

Licensed under The Artistic License 2.0
See LICENSE for details or
http://www.perlfoundation.org/artistic_license_2_0
"""


import sys
import re
import simplejson
from log import log

__version__ = "0.02"

def has_keys (dict, needles) :
    found = False 
    for needle in needles :
        if dict.get(needle) :
            found = True
    return found
def escape_csv_elem (csv_str) :                                                                                                          
    csv_str = csv_str.replace(",", ".cma.")
    return csv_str

def unescape_csv_elem (csv_str) :                                                                                                          
    csv_str = csv_str.replace(".cma.", ",")
    return csv_str
def sql_escape (col_array) : #not being used
    ret_array = []
    for col in col_array :
        ret_array.append(col.replace("'", "\\'"))
    return ret_array
def escape_args(args) :
    for key in args :
        args[key] = args[key].replace("'", "\\'")
    return args
def mk_select_result(dbh, query) :
    result = []
    cursor = dbh.cursor()
    cursor.execute(query)
    rows = cursor.fetchall()
    for row in rows :
        result.append( {row[0]:row[1]} )
    return result

def cfg_to_str (replace_dict) :
    clan_cfg = __import__("clanrc")
    cfgs = dir(clan_cfg)
    cfg_str = ""
    found = False
    for c in cfgs :
        if c[:1] == "_" :
            continue
        value = eval("clan_cfg.%s" % c)
        if replace_dict.has_key(c) :
            value = replace_dict.get(c)
            found = True
        if type(value) == type(1) or type(value) == type(True):
            cfg_str+= "%s = %s\n" % (c, value) 
        else :
            cfg_str+= "%s = '%s'\n" % (c, value) 
    if not found:
        for key in replace_dict:
            value = replace_dict[key]
            if type(value) == type(1) or type(value) == type(True):
                cfg_str+= "%s = %s\n" % (key, value) 
            else :
                cfg_str+= "%s = '%s'\n" % (key, value) 
    return cfg_str

def update_rc(rep_dict):
    """
    Example of rep_dict:   
    rep_dict = { "hostname": "your host name" }
    """
    cfg_str = cfg_to_str(rep_dict) 
    fh = open("clanrc.py", "w+")
    fh.write(cfg_str)
    fh.close()
    if sys.modules.get("clanrc"):
        sys.modules.pop("clanrc")
    import clanrc 
 

def save_hosts_conf(host_desc, kwdict):
    """
    write hosts_conf settings away. not using **kwargs since getting params from rpc, 
    """
    try:
        c = __import__("conf.hosts_conf") 
        if not c.hosts_conf.hosts.has_key(host_desc):
            return False
        for kw in kwdict:
            c.hosts_conf.hosts.get(host_desc)[kw] = kwdict[kw]
    except:
        log(sys.exc_value)
        return False
    text = simplejson.dumps(c.hosts_conf.hosts, indent=4)
    text = "hosts = " + text
    fh = open("conf/hosts_conf.py", "w")
    fh.write(text)
    fh.close()
    return True


class request :
    req = None
    def __init__(self, req) :
        self.req = req
    def get (self, name) :
        try :
            if self.req :
                value = self.req.get(name)[0]
            return value
        except :
            return ""




    def search (self, exp) :
        try :
            for itm in self.req :		
                if eval("re.match(r'"+exp+"', itm) ") :
                    return itm
        except :
            return ""
        return ""
